<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_AdmTeachers extends Controller_Handler {
        
        public function before() {
            $this->model = new Model_Admin_Teachers;
            $this->setAccessLevel(self::ACCESS_USER);
            parent::before();
        }
        
        protected function createTeacher($firstName, $secondName, $lastName, $degreeID, $departamentID)
        {
            $activationCode = Account::instance()->createTeacher($firstName, $secondName, $lastName, $degreeID, $departamentID);
            return $activationCode;
        }
        
        public function action_getTeachersList()
        {
            $departmentID = $this->post->offsetGet('departmentID');
            $facultyID = $this->post->offsetGet('facultyID');
            $teachersHandled = array();
            if($departmentID != 0)
            {
                $teachers = $this->model->getTeachersByDepartment($departmentID);
                $i = 0;
                foreach($teachers as $row)
                {
                    $i++;
                    $teachersHandled[$i]['ID'] = $row['TeacherID'];
                    $teachersHandled[$i]['FirstName'] = $row['TeacherFirst'];
                    $teachersHandled[$i]['SecondName'] = $row['TeacherSecond'];
                    $teachersHandled[$i]['LastName'] = $row['TeacherLast'];
                    $teachersHandled[$i]['JobPositionName'] = $row['DegreeName'];
                    $teachersHandled[$i]['DepartmentName'] = $row['DepName'];
                }
                
            }
            elseif($facultyID != 0)
            {
                $teachers = $this->model->getTeachersByFaculty($facultyID);
                $i = 0;
                foreach($teachers as $row)
                {
                    $i++;
                    $teachersHandled[$i]['ID'] = $row['TeacherID'];
                    $teachersHandled[$i]['FirstName'] = $row['TeacherFirst'];
                    $teachersHandled[$i]['SecondName'] = $row['TeacherSecond'];
                    $teachersHandled[$i]['LastName'] = $row['TeacherLast'];
                    $teachersHandled[$i]['JobPositionName'] = $row['DegreeName'];
                    $teachersHandled[$i]['DepartmentID'] = $row['DepID'];
                    $teachersHandled[$i]['DepartmentName'] = $row['DepName'];
                }                
            }
            $twig = Twig::factory('admin/teachers/handler/listOutput');
            $twig->List = $teachersHandled;
            $this->response->body($twig);
        }
        
        public function action_getDepartmentsList()
        {
            $facultyID = $this->post->offsetGet('facultyID');
            if($facultyID != 0)
            {
                $departaments = $this->model->getDepartmentsByFaculty($facultyID);
                $departamentsHandled = array(); $i = 0;
                foreach($departaments as $row)
                {
                    $i++;
                    $departamentsHandled[$i]['ID'] = $row['DepID'];
                    $departamentsHandled[$i]['Name'] = $row['DepName'];
                }
                $this->response->body(json_encode($departamentsHandled));
            }
        }
}